function varargout = Resultados(varargin)
% RESULTADOS MATLAB code for Resultados.fig
%      RESULTADOS, by itself, creates a new RESULTADOS or raises the existing
%      singleton*.
%
%      H = RESULTADOS returns the handle to a new RESULTADOS or the handle to
%      the existing singleton*.
%
%      RESULTADOS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in RESULTADOS.M with the given input arguments.
%
%      RESULTADOS('Property','Value',...) creates a new RESULTADOS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Resultados_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Resultados_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Resultados

% Last Modified by GUIDE v2.5 17-Mar-2017 15:50:28

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Resultados_OpeningFcn, ...
                   'gui_OutputFcn',  @Resultados_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Resultados is made visible.
function Resultados_OpeningFcn(hObject, eventdata, handles, varargin)
    
    handles.datos.patron = varargin{1};
    handles.datos.X = varargin{2};
    handles.datos.Y = varargin{3};
    handles.datos.U = varargin{4};
    handles.datos.V = varargin{5};
    handles.datos.ancho = varargin{6};
    handles.datos.alto  = varargin{7};
    cte = varargin{8};
    
    
    tam_patron = size(handles.datos.patron);
    
    % Calcular los campos escalares
    ancho = handles.datos.ancho;
    alto  = handles.datos.alto;
    
    U_tot = zeros(tam_patron(1),tam_patron(2));
    V_tot = zeros(tam_patron(1),tam_patron(2));
    
    numY = floor(tam_patron(2)/ancho);
    numX = floor(tam_patron(1)/alto);
    
    for i=1:numY
        for j=1:numX
            U_tot(alto*(j-1)+1:alto*j,ancho*(i-1)+1:ancho*i) = handles.datos.U(j,i)*ones(alto,ancho)*cte;
            V_tot(alto*(j-1)+1:alto*j,ancho*(i-1)+1:ancho*i) = handles.datos.V(j,i)*ones(alto,ancho)*cte;
        end
    end
    Mag = sqrt(U_tot.^2 + V_tot.^2);
    
    % Tomar la posici� central de los ejes y la m�ima anchura, altura
    pos = get(handles.ejesPatron,'Position');
    ancho_max = pos(3);
    alto_max = pos(4);
    pos_central = [pos(1)+pos(3)/2, pos(2)+pos(4)/2];
    
    prop_grafica = ancho_max/alto_max; % Proporcion
    prop_patron  = tam_patron(2)/tam_patron(1);
    
    if prop_patron > prop_grafica % Domina ancho -> Bajar alto
        pos(4) = ancho_max/prop_patron;
        pos(2) = pos_central(2) - pos(4)/2;
    else % Domina alto -> Bajar ancho
        pos(3) = alto_max*prop_patron;
        pos(1) = pos_central(1) - pos(3)/2;
    end
    
    handles.hImagen = imshow(handles.datos.patron,'Parent',handles.ejesPatron);
    set(handles.ejesPatron,'XLim',[0.5 tam_patron(2)+0.45],'YLim',[0.5 tam_patron(1)+0.45],'Position',pos,'box','on','tickdir','out','nextplot','add','ydir','reverse','XTick',[],'YTick',[],'XLimMode','manual','YLimMode','manual');
    colormap(gray);
    handles.hVect = quiver(handles.datos.X,handles.datos.Y,handles.datos.U,handles.datos.V,'Parent',handles.ejesPatron,'Color','y','LineWidth',1.3,'AutoScaleFactor',1);
    maximo = max(max(Mag));
    minimo = min([min(min(U_tot)), min(min(V_tot))]);
    handles.datos.V_color = escala_colores((Mag    - minimo)./(maximo - minimo));
    handles.datos.Vx_color  = escala_colores((U_tot  - minimo)./(maximo - minimo));
    handles.datos.Vy_color  = escala_colores((V_tot  - minimo)./(maximo - minimo));
    
    % Definir escala colores
    marcas{1} = sprintf('%.2f',minimo);
    marcas{2} = sprintf('%.2f',minimo + (maximo-minimo)/4);
    marcas{3} = sprintf('%.2f',(maximo + minimo)/2);
    marcas{4} = sprintf('%.2f',maximo - (maximo-minimo)/4);
    marcas{5} = sprintf('%.2f',maximo);
    set(handles.ejesColores,'YLim',[0 1],'XLim',[0 1],'nextplot','add','YTick',[0 0.25 0.5 0.75 1],'YTickLabel',marcas,'XTick',[],'YAxisLocation','right')
    n_colores = 100;
    alto = 1/n_colores;
    for i=1:n_colores
        t = alto*(i-1) + alto/2;
        patch([0 1 1 0],[alto*(i-1) alto*(i-1) alto*i alto*i],escala_colores(t),'Parent',handles.ejesColores,'LineStyle','none');
    end
    set(hObject,'CurrentAxes',handles.ejesPatron);
    
    handles.datos.Mag = Mag;
    handles.datos.U_tot = U_tot;
    handles.datos.V_tot = V_tot;
    
% Choose default command line output for Resultados
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Resultados wait for user response (see UIRESUME)
% uiwait(handles.figureResultados);


% --- Outputs from this function are returned to the command line.
function varargout = Resultados_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in checkMostrarCampo.
function checkMostrarCampo_Callback(hObject, eventdata, handles)
if get(hObject,'Value')
    set(handles.panelCampo,'visible','on')
    if get(handles.radioEscalar,'Value')
        set(handles.hImagen,'visible','on');
        set(handles.panelCampoEscalar,'visible','on');
        set(handles.checkMostrarImagen,'enable','off');
        Vx = get(handles.radioVx,'value');
        Vy = get(handles.radioVy,'value');
        V  = get(handles.radioV,'value');
        switch(1)
            case Vx
                set(handles.hImagen,'CData',handles.datos.Vx_color);
            case Vy
                set(handles.hImagen,'CData',handles.datos.Vy_color);
            case V
                set(handles.hImagen,'CData',handles.datos.V_color);
        end
    else
        set(handles.hVect,'visible','on');
        if get(handles.checkMostrarImagen,'value')
            set(handles.hImagen,'CData',handles.datos.patron);
            set(handles.hImagen,'visible','on');
        else
            set(handles.hImagen,'visible','off');
        end
    end
else
    set(handles.checkMostrarImagen,'enable','on');
    if get(handles.checkMostrarImagen,'value')
        set(handles.hImagen,'CData',handles.datos.patron);
        set(handles.hImagen,'visible','on');
    else
        set(handles.hImagen,'visible','off');
    end
    set(handles.panelCampo,'visible','off');
    set(handles.panelCampoEscalar,'visible','off');
    set(handles.hVect,'visible','off');
    
end


function checkMostrarImagen_Callback(hObject, eventdata, handles)
if get(hObject,'Value')
    set(handles.hImagen,'visible','on');
else
    set(handles.hImagen,'visible','off');
end

% --- Executes when selected object is changed in panelCampo.
function panelCampo_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in panelCampo 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
if isequal(eventdata.NewValue,handles.radioVectorial)
    set(handles.hVect,'visible','on');
    set(handles.checkMostrarImagen,'enable','on');
    set(handles.panelCampoEscalar,'visible','off');
    set(handles.hImagen,'CData',handles.datos.patron);
    if get(handles.checkMostrarImagen,'value');
        set(handles.hImagen,'Visible','on');
    else
        set(handles.hImagen,'Visible','off');
    end
else
    set(handles.hVect,'visible','off');
    set(handles.checkMostrarImagen,'enable','off');
    set(handles.panelCampoEscalar,'visible','on');
    Vx = get(handles.radioVx,'value');
    Vy = get(handles.radioVy,'value');
    V  = get(handles.radioV,'value');
    switch(1)
        case Vx
            set(handles.hImagen,'CData',handles.datos.Vx_color);
        case Vy
            set(handles.hImagen,'CData',handles.datos.Vy_color);
        case V
            set(handles.hImagen,'CData',handles.datos.V_color);
    end
    set(handles.hImagen,'visible','on');
end


% --- Executes when selected object is changed in panelCampoEscalar.
function panelCampoEscalar_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in panelCampoEscalar 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
switch(eventdata.NewValue)
    case handles.radioVx
        set(handles.hImagen,'CData',handles.datos.Vx_color);
    case handles.radioVy
        set(handles.hImagen,'CData',handles.datos.Vy_color);
    case handles.radioV
        set(handles.hImagen,'CData',handles.datos.V_color);
end
    


% --- Executes on mouse motion over figure - except title and menu.
function figureResultados_WindowButtonMotionFcn(hObject, eventdata, handles)
        handles.datos.pos_raton = get(hObject,'CurrentPoint'); % La posici� del rat� en la figura
        axes_area = get(handles.ejesPatron,'Position'); % El �ea que abarca los ejes
        
        if (handles.datos.pos_raton(1,1) < (axes_area(1) + axes_area(3))) && ...
                (handles.datos.pos_raton(1,1) > (axes_area(1))) && ...
                (handles.datos.pos_raton(1,2) < (axes_area(2) + axes_area(4))) && ...
                (handles.datos.pos_raton(1,2) > (axes_area(2))) % En ejes
            
            pos_raton = get(handles.ejesPatron,'CurrentPoint'); % Posici� del rat� en la grafica
            j = round(pos_raton(1,1));
            i = round(pos_raton(1,2));
            
            if i > size(handles.datos.Mag,1)
                i = i -1;
            end
            if j > size(handles.datos.Mag,2)
                j = j -1;
            end
            set(handles.labelVelocidad,'String',sprintf('V = %.3f m/s\nVx = %.3f m/s\nVy = %.3f m/s',handles.datos.Mag(i,j),handles.datos.U_tot(i,j),handles.datos.V_tot(i,j)));
        else
            set(handles.labelVelocidad,'String','');
        end


function botonVistaCompleta_Callback(hObject, eventdata, handles)
    figure('Numbertitle','off','Name',sprintf('Campo de velocidades - Ventana de %d x %d p�els',handles.datos.ancho,handles.datos.alto),'Color','w');
    ejesPantCompl = axes;
    imshow(get(handles.hImagen,'CData'));
    if get(handles.radioVectorial,'Value')
        hold on;
        copyobj(handles.hVect,ejesPantCompl);
    end
    set(0,'CurrentFigure',handles.figureResultados);
    
    

% --- Executes on button press in guardarimagen.
function guardarimagen_Callback(hObject, eventdata, handles)
% hObject    handle to guardarimagen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
rgb=getframe(handles.ejesPatron);
    if isempty(rgb)
        return
    end
    
fileTypes=supportedImageTypes;
[f,p]=uiputfile(fileTypes);

    if f==0
         return
    end
    
fName=fullfile(p,f);
imwrite(rgb.cdata,fName);
msgbox(['Imagen guardada en ' fName]);
    
function fileTypes=supportedImageTypes
        
fileTypes={'*.jpg','JPEG(*.jpg)';'*.tif','TIFF(*.tif)';'*.bmp','Bitmap(*.bmp)';'*.*','All files (*.*)'};



% --- Executes on button press in creagif.
function creagif_Callback(hObject, eventdata, handles)
% hObject    handle to creagif (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
for i=1:3
    a=strcat('gif',num2str(i), '.jpg');
    img=imread(a);
    b(i)=im2frame(img);
end
movie(b,10,2) %reproduce b, 5 veces, 10 cuadrados por segundo
set(handles.figureResultados,'CurrentAxes',handles.ejesPatron)
axis off;
